import javax.swing.*;          
import java.awt.*;
import java.awt.event.*;

public class VacuumGUIDemo implements ActionListener {
    
    private static String labelPrefix = "Number of actions: ";
    private static String labelPostfix = "   Performance: ";
    private ImageIcon cleanerDirtyIcon = new ImageIcon("cleaner_dirty.gif");
    private ImageIcon cleanerCleanIcon = new ImageIcon("cleaner_clean.gif");
    private ImageIcon dirtyIcon = new ImageIcon("dirty.gif");
    private ImageIcon cleanIcon = new ImageIcon("clean.gif");
    private int numActions = 0;
    private JLabel locationALabel, locationBLabel, performanceLabel;
     
	private static TrivialVaccumEnvironment vEnvironment = new TrivialVaccumEnvironment("Dirty","Dirty");
	private static ModelBasedTVEVaccumAgent vAgent = new ModelBasedTVEVaccumAgent();
	private static BasicEnvironmentView vView = new BasicEnvironmentView();
    
    public Component createComponents() {
    	
    	locationALabel = new JLabel("A", cleanerDirtyIcon, JLabel.CENTER);
     	locationALabel.setVerticalTextPosition(JLabel.BOTTOM);
        locationALabel.setHorizontalTextPosition(JLabel.CENTER);
           	
    	locationBLabel = new JLabel("B", dirtyIcon, JLabel.CENTER);
    	locationBLabel.setVerticalTextPosition(JLabel.BOTTOM);
        locationBLabel.setHorizontalTextPosition(JLabel.CENTER);
        
        performanceLabel = new JLabel(labelPrefix + "0" + labelPostfix + "0", JLabel.CENTER);
        
        JButton button = new JButton("Perform Action");
        button.addActionListener(this);
        
        JPanel mainPane = new JPanel(new BorderLayout());
        JPanel imagePane = new JPanel(new GridLayout(1, 2));
        
        setLocationLabels();
        imagePane.add(locationALabel);
        imagePane.add(locationBLabel);
        
        mainPane.add(imagePane, BorderLayout.CENTER);
        mainPane.add(performanceLabel, BorderLayout.NORTH);
        mainPane.add(button, BorderLayout.SOUTH);
        
        return mainPane;
    }
    
    public void setLocationLabels()	{
    	
    	if(vEnvironment.getAgentLocation(vAgent) == "A") {
 			if(vEnvironment.getLocationStatus("A") == "Dirty") 
 				locationALabel.setIcon(cleanerDirtyIcon);
 			else locationALabel.setIcon(cleanerCleanIcon);
 			if(vEnvironment.getLocationStatus("B") == "Dirty")
 				locationBLabel.setIcon(dirtyIcon);
 			else locationBLabel.setIcon(cleanIcon);	
 		}
     	else if(vEnvironment.getAgentLocation(vAgent) == "B") {
 			if(vEnvironment.getLocationStatus("B") == "Dirty") 
 				locationBLabel.setIcon(cleanerDirtyIcon);
 			else locationBLabel.setIcon(cleanerCleanIcon);
 			if(vEnvironment.getLocationStatus("A") == "Dirty")
 				locationALabel.setIcon(dirtyIcon);
 			else locationALabel.setIcon(cleanIcon);	
 		}
 		else	{
 			if(vEnvironment.getLocationStatus("A") == "Dirty") 
 				locationALabel.setIcon(dirtyIcon);
 			else locationALabel.setIcon(cleanIcon);
 			if(vEnvironment.getLocationStatus("B") == "Dirty") 
 				locationBLabel.setIcon(dirtyIcon);
 			else locationBLabel.setIcon(cleanIcon);
 		}
	}

    public void actionPerformed(ActionEvent e) {
             
        vEnvironment.step(1);
               
        setLocationLabels();        
        performanceLabel.setText(labelPrefix + ++numActions + labelPostfix + vEnvironment.getAgentPerformance(vAgent));
    }

 
    private static void createAndShowGUI() {
    	
		vEnvironment.addAgent(vAgent, "B");
		vEnvironment.registerView(vView);
		
        JFrame frame = new JFrame("VacuumGUIDemo");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        VacuumGUIDemo app = new VacuumGUIDemo();
        Component contents = app.createComponents();
        frame.getContentPane().add(contents, BorderLayout.CENTER);
         
        frame.pack();
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
}
